
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//|                                              BrainTrend1Stop.mq4 |
//|                                          BrainTrend Black edition|
//|                                      http://www.braintrading.com |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+



#property copyright "BrainTrend Black edition"
#property link      "http://www.braintrading.comt"
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Magenta
#property indicator_color2 Aqua






extern int    arrowtype    = 119;
extern int    EnableAlerts = 0;
extern int    SignalID     = 0;
extern int    Length       = 1;
extern int    Price        = 0;
extern double Phase        = 5;
extern int    f            = 7;
extern int    s            = 1.5;
extern int    x1           = 53;
extern int    x2           = 47;
extern int    value11      = 9;






double Ind_Buffer1[];
double Ind_Buffer2[];

double value2;
double value3;
double value4;
double value5;
double value6;
double Range;
double range1;
double val1;
double val2;
double val3;
double a1,r;
double bs;
double bs1;

int p = 0;
int d = 2.3;





int init()
  {
   string short_name;
   SetIndexBuffer(0,Ind_Buffer1); SetIndexStyle (0,DRAW_ARROW); SetIndexArrow (0,arrowtype ); SetIndexLabel(0,""+short_name+"_SELL");
   SetIndexBuffer(1,Ind_Buffer2); SetIndexStyle (1,DRAW_ARROW); SetIndexArrow (1,arrowtype ); SetIndexLabel(1,""+short_name+"_BUY" );
   
   short_name="BrainTrend1Stop";
   IndicatorShortName(short_name);
   
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));

   return(0);
  }
   
int start()
  {
   double CloseVal, CloseVal2, HighVal, LowVal;
   Comment("BrainTrading Inc. System 7.0");
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
      for(i=limit; i>=0; i--)
      { 
      Range  = iATR(NULL,0,f, i)/ d;
      range1 = iATR(NULL,0,10,i)* s;
      value2 = iStochastic(NULL,0,value11,value11,1,0,0,0,i);
      CloseVal  = NormalizeDouble(iSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i  ),Length,Phase,i,   0),Digits);
      CloseVal2 = NormalizeDouble(iSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i+2),Length,Phase,i+2,10),Digits);
      
      HighVal = NormalizeDouble(iSmooth(iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i),Length,Phase,i,20),Digits);
      LowVal  = NormalizeDouble(iSmooth(iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW, i),Length,Phase,i,30),Digits);
      
      val1 = 0;
      val2 = 0;
      val3 = MathAbs(CloseVal - CloseVal2);
      if (value2 < x2 && val3 > Range&& p != 1 )
         {
         value3 = HighVal + range1 / 4;
         val1 = value3;
         p = 1; 
         r = val1; 
         bs = r; 
         Ind_Buffer1[i]=val1; 
         Ind_Buffer2[i]=0;       
         }
         if (value2 > x1 && val3 > Range && p != 2 ) 
         {
         value3 = LowVal - range1/ 4;
         val2 = value3;
         p = 2;
         r = val2; 
         bs = r; 
         Ind_Buffer1[i]=0;
         Ind_Buffer2[i]=val2;   
         }
         value4 = HighVal + range1;
         value5 = LowVal - range1;
         if (val1 == 0 && val2 == 0 && p == 1 )
         {
         if (value4 < r)
          {
          r = value4; 
          bs = r; 
          Ind_Buffer1[i]=r; 
          Ind_Buffer2[i]=0;
          }
         else
          {
          bs = r; 
          Ind_Buffer1[i]=r; 
          Ind_Buffer2[i]=0;}
          }
         if( val1 == 0 && val2 == 0 && p == 2 && value5 >  r)                   
          {
          r = value5; 
          bs = r; 
          Ind_Buffer1[i]=0; 
          Ind_Buffer2[i]=r;
          }
         if( val1 == 0 && val2 == 0 && p == 2 && value5 <= r)        
          {
          bs = r; 
          Ind_Buffer1[i]=0; 
          Ind_Buffer2[i]=r;
          }      
         
        }
   
   if (EnableAlerts == 1 && bs > 0 && bs != bs1)
      {
      bs1 = bs;
      a1 = FileOpen("alert1" + SignalID,";");
      FileWrite(a1,"BT1Stop value for " , Symbol() , " is " , bs , " Current Close=" , Close[i] , " M" + Period());
      FileClose(a1);
      }

   return(0);
  }
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+


    
double wrk[][40];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

  
double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}